// Licensed Materials - Property of IBM
// 5725-C94, 5725-C95, 5725-C96, 5724-M24, 5724-I82, 5724-N72 
// Copyright International Business Machines Corp. 2006, 2011
// All Rights Reserved
// US Government Users Restricted Rights - Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.


// read an external file in IE
// securityFcn: function = new Function('return window')
// fileName: string - full native file name
// returns: [line strings]
function secureReadTextFileIE(securityFcn,fileName) {
  try {

    if (!top.isSecure(securityFcn)) {
        return null;
    }

    var fileContents = null;

    // Try to read file using XMLHttpRequest 
    try {
        var xmlReq = new ActiveXObject("Microsoft.XMLHTTP");

        // Do a synchronous read on the file       
        xmlReq.open("GET", fileName, false);
        xmlReq.send(null);
        fileContents = xmlReq.responseText;
    }
    catch(e) {
        //Log this exception, then try to fallback to ADODB.stream        
        alert(e.name);// alerts 'Error'
		alert(e.message); // alerts 'The message' or a JavaScript error message)
        try
        {
            var objectStream = new ActiveXObject("ADODB.Stream");
             
            objectStream.Type=2;
            objectStream.Charset="UTF-8";
            objectStream.open();
            objectStream.LoadFromFile(fileName);              
            fileContents = objectStream.ReadText();
            objectStream.close();
        }
        //If an exception is caught, this means we can't use ADODB.stream, so we have use FSO to do
        //the file read.
        catch(e)
        {
          //If ADODB.stream fails, log it and try FSO
          alert(e.name);// alerts 'Error'
		  alert(e.message); // alerts 'The message' or a JavaScript error message)
          fileContents = null;
          var fileSystemObject = new ActiveXObject("Scripting.FileSystemObject");

          var handle = fileSystemObject.GetFile(fileName);
          var O_READONLY = 1;
          var asUnicode = -1;
	      var stream = handle.OpenAsTextStream(O_READONLY, asUnicode);

          var uniContents = stream.ReadAll();
	      stream.close();

          var rawContents = '';
	      for (var i=0; i < uniContents.length; i++) {
	          var charCode = uniContents.charCodeAt(i);
	          rawContents += String.fromCharCode(charCode & 255, charCode >> 8);
	      }
	      if (handle.size > rawContents.length) {        
              if (typeof top.fileReadErrorList == "undefined") {
                      alert(e.name);// alerts 'Error'
					  alert(e.message); // alerts 'The message' or a JavaScript error message)
              }
              //This is just here so we don't log a message for the same file over and over again.
              if (typeof top.fileReadErrorList[fileName] == "undefined") {
                  top.fileReadErrorList[fileName]=true;
                    alert(e.name);// alerts 'Error'
					alert(e.message); // alerts 'The message' or a JavaScript error message)
              }                 
	      }
          fileContents = top.UTF8toString(rawContents);      
        } // End of ADODB catch
    } // End of XMLHttpRequest catch

    //Removes BOM characters from the beginning of the file
    
    if (fileContents.charCodeAt(0) == '65279' || fileContents.charCodeAt(0) == '65534')
    {     
      fileContents = fileContents.substring(1,fileContents.length);   
    }

    return fileContents;

  } catch(e) {
    //FSO failed, there's nothing we can do to read this files    
    alert(e.name);// alerts 'Error'
	alert(e.message); // alerts 'The message' or a JavaScript error message)
  }
}

// read an external file in mozilla
// securityFcn: function = new Function('return window')
// fileName: string - full native file name
// returns: [line strings]
function secureReadTextFileMoz(securityFcn,fileName)
{
    try {
        if ( top.isSecure(securityFcn) )
            netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
        var nsILocalFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
        nsILocalFile.initWithPath( fileName );
        if ( nsILocalFile.exists() == false )
        {
			// file doesn't exist yet
			return "";
        }
        var nsIFileInputStream = Components.classes["@mozilla.org/network/file-input-stream;1"]
        .createInstance( Components.interfaces.nsIFileInputStream);
        nsIFileInputStream.init( nsILocalFile, 0x01, 00004, null);
        var nsIBinaryInputStream = Components.classes["@mozilla.org/binaryinputstream;1"]
        .createInstance( Components.interfaces.nsIBinaryInputStream);
        nsIBinaryInputStream.setInputStream(nsIFileInputStream);
        var fileContents = top.UTF8toString(nsIBinaryInputStream.readBytes(nsIFileInputStream.available()));

        nsIFileInputStream.close();
        nsIBinaryInputStream.close();

        //Removes BOM characters from the beginning of the file
        if (fileContents.charCodeAt(0) == '65279' || fileContents.charCodeAt(0) == '65534')
        {
            fileContents = fileContents.substring(1,fileContents.length);   
        }

        return fileContents;
    } catch(e)
    {
        alert(e.name);// alerts 'Error'
		alert(e.message); // alerts 'The message' or a JavaScript error message)
    }
    return top.UNDEFINED;
}

function init()
{
	setInterval(init2,5000);
}

function init2() 
{
	var PROFILEROOT="${PROFILEROOT}";
	var SERVERNAME="${SERVERNAME}";

	if (navigator.userAgent.indexOf('MSIE') !=-1)
	{
		// Using IE
		fileContents = secureReadTextFileIE(securityCheck, PROFILEROOT+"/logs/"+SERVERNAME+"_wsrrivt.log");
	} else {
		// Moz
		fileContents = secureReadTextFileMoz(securityCheck,PROFILEROOT+"/logs/"+SERVERNAME+"_wsrrivt.log");
	}
	var logout = "<pre>" + fileContents + "</pre>";
	var preSection=document.getElementById("logoutput");
	preSection.innerHTML=logout;
}